/*!
 * vuetify-daterange-picker v1.1.0
 * (c) 2018-present Praveen Puglia <praveenpuglia@gmail.com>
 */
'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var moment = _interopDefault(require('moment'));

var DateRange = { render: function () {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('div', { staticClass: "date-range" }, [_c('div', { staticClass: "date-range__presets" }, [_c('v-list', [_c('v-subheader', [_vm._v("Presets")]), _vm._v(" "), _vm._l(_vm.presets, function (preset, index) {
      return _c('v-list-tile', { key: index, attrs: { "ripple": "" }, on: { "click": function ($event) {
            _vm.onPresetSelect(index);
          } }, model: { value: _vm.isPresetActive[index], callback: function ($$v) {
            _vm.$set(_vm.isPresetActive, index, $$v);
          }, expression: "isPresetActive[index]" } }, [_c('v-list-tile-content', [_vm._v(" " + _vm._s(preset.label) + " ")])], 1);
    })], 2)], 1), _vm._v(" "), _c('div', { staticClass: "date-range__pickers" }, [_c('div', { staticClass: "date-range__picker date-range__pickers--start" }, [_c('v-text-field', { staticClass: "date-range__pickers-input", attrs: { "name": "startDate", "label": ("Start Date(" + (_vm.format) + ")"), "prepend-icon": "event", "readonly": "readonly" }, model: { value: _vm.formattedStartDate, callback: function ($$v) {
          _vm.formattedStartDate = $$v;
        }, expression: "formattedStartDate" } }), _vm._v(" "), _c('v-date-picker', { attrs: { "allowed-dates": _vm.allowedStartDates, "no-title": "" }, on: { "change": _vm.onDateRangeChange }, model: { value: _vm.startDate, callback: function ($$v) {
          _vm.startDate = $$v;
        }, expression: "startDate" } })], 1), _vm._v(" "), _c('div', { staticClass: "date-range__picker date-range__picker--end" }, [_c('v-text-field', { staticClass: "date-range__pickers-input", attrs: { "name": "endDate", "label": ("End Date(" + (_vm.format) + ")"), "readonly": "readonly" }, model: { value: _vm.formattedEndDate, callback: function ($$v) {
          _vm.formattedEndDate = $$v;
        }, expression: "formattedEndDate" } }), _vm._v(" "), _c('v-date-picker', { attrs: { "allowed-dates": _vm.allowedEndDates, "no-title": "" }, on: { "change": _vm.onDateRangeChange }, model: { value: _vm.endDate, callback: function ($$v) {
          _vm.endDate = $$v;
        }, expression: "endDate" } })], 1)])]);
  }, staticRenderFns: [], _scopeId: 'data-v-a39c29f4',
  props: {
    options: {
      type: Object,
      required: true
    }
  },
  data: function data() {
    return {
      startDate: this.options.startDate,
      endDate: this.options.endDate,
      format: this.options.format,
      presets: this.options.presets
    };
  },
  computed: {
    formattedStartDate: function formattedStartDate() {
      return moment(this.startDate).format(this.format);
    },
    formattedEndDate: function formattedEndDate() {
      return moment(this.endDate).format(this.format);
    },
    isPresetActive: function isPresetActive() {
      var this$1 = this;

      return this.presets.map(function (preset) { return preset.range[0] === this$1.startDate && preset.range[1] === this$1.endDate; });
    },
    allowedStartDates: function allowedStartDates() {
      return {
        min: this.options.minDate,
        max: this.endDate
      };
    },
    allowedEndDates: function allowedEndDates() {
      return {
        min: this.startDate,
        max: moment().format("YYYY-MM-DD")
      };
    }
  },
  watch: {
    startDate: function startDate() {
      this.onDateRangeChange();
    },
    endDate: function endDate() {
      this.onDateRangeChange();
    }
  },
  methods: {
    onPresetSelect: function onPresetSelect(presetIndex) {
      this.startDate = this.presets[presetIndex].range[0];
      this.endDate = this.presets[presetIndex].range[1];
    },
    onDateRangeChange: function onDateRangeChange() {
      this.$emit("input", [this.startDate, this.endDate]);
    }
  }
};

module.exports = DateRange;
